#include <owl\owlpch.h>
#pragma hdrstop

#include <imagelst.h>

// ---------------------------------------------------------------------------

TImageList::TImageList( int cx, int cy, UINT flags, int cInitial, int cGrow, BOOL Owner)
{
   hImageList = ImageList_Create(cx, cy, flags, cInitial, cGrow);
   IsOwner = Owner;
}

// ---------------------------------------------------------------------------

TImageList::TImageList()
{
   hImageList = 0;
   IsOwner = FALSE;
}

// ---------------------------------------------------------------------------

TImageList::TImageList( HIMAGELIST hImgList, BOOL Owner)
{
   hImageList = hImgList;
   IsOwner = Owner;
}

// ---------------------------------------------------------------------------

TImageList::~TImageList()
{
   if ( ( IsOwner) && ( hImageList))
      ImageList_Destroy( hImageList);
}

// ---------------------------------------------------------------------------

TImageList::operator HIMAGELIST()
{
   return hImageList;
}

// ---------------------------------------------------------------------------

int TImageList::Add( HBITMAP hImage, HBITMAP hMask)
{
   return ImageList_Add( hImageList, hImage, hMask);
}

// ---------------------------------------------------------------------------

int TImageList::AddIcon( HICON hImage)
{
   return ImageList_AddIcon( hImageList, hImage);
}

// ---------------------------------------------------------------------------

BOOL TImageList::Remove( int iItem)
{
   return ImageList_Remove( hImageList, iItem);
}

// ---------------------------------------------------------------------------

BOOL TImageList::RemoveAll()
{
   return ImageList_RemoveAll( hImageList);
}

// ---------------------------------------------------------------------------

inline BOOL TImageList::Replace( int iItem, HBITMAP hImage, HBITMAP hMask)
{
   return ImageList_Replace( hImageList, iItem, hImage, hMask);
}

// ---------------------------------------------------------------------------

BOOL TImageList::ReplaceIcon( int iItem, HICON hImage)
{
   return ImageList_ReplaceIcon( hImageList, iItem, hImage);
}

// ---------------------------------------------------------------------------

BOOL TImageList::Draw( int iDraw, HDC hdcDst, int x, int y, UINT fStyle)
{
   return ImageList_Draw( hImageList, iDraw, hdcDst, x, y, fStyle);
}

// ---------------------------------------------------------------------------

BOOL TImageList::DrawEx( int iDraw, HDC hdcDst,int x, int y, int cx, int cy,
                         COLORREF rgbBk, COLORREF rgbFg, UINT fStyle)
{
   return ImageList_DrawEx( hImageList, iDraw, hdcDst, x, y, cx, cy,
                         rgbBk, rgbFg, fStyle);
}

// ---------------------------------------------------------------------------

HICON TImageList::ExtractIcon( int hItem)
{
   return ImageList_ExtractIcon( 0, hImageList, hItem);
}

// ---------------------------------------------------------------------------

HICON TImageList::GetIcon( int hItem, UINT style)
{
   return ImageList_GetIcon( hImageList, hItem, style);
}

// ---------------------------------------------------------------------------

BOOL TImageList::SetIconSize( int cx, int cy)
{
   return ImageList_SetIconSize( hImageList, cx, cy);
}

// ---------------------------------------------------------------------------

int TImageList::GetImageCount()
{
   return ImageList_GetImageCount( hImageList);
}

// ---------------------------------------------------------------------------
